#include "ctpuz.h"
	.data
dummy:
	.long	dummy
	
	.text

#define map_pattern \
	movl	%edi, %esi ; \
	shrl	$10, %edi ; \
	andl	$0xa, %esi ; \
	andl	$0x4, %edi ; \
	orl	%esi, %edi ; \
	shrl	$1, %edi
	

	.p2align 4,,15
.globl solve_asm
	.type	solve_asm,@function
solve_asm:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	pushl	%esi

	movl	8(%ebp), %ebx
	movl	12(%ebp), %edx
#ifdef COUNT_PLACED
	movl	20(%ebp), %ebp
#endif
	movl	$dummy, %eax
	movl	%eax, %ecx

	call	solve_asm_64
	popl	%esi
	popl	%ebx
	popl	%ebp
	ret
	
	.p2align 4,,15
.globl solve_asm_64
	.type	solve_asm_64,@function
solve_asm_64:
	movl	(%ecx),%esi
	pushl	%edi
	movl	%esi,(%eax)
	pushl	%eax
	pushl	%ecx

#ifdef COUNT_PLACED
	incl	placedP-4(,%ebp,4)
	incl	%ebp
#endif
	incl	placed

	cmpl	$-1, %ebx
	jz	hole_detect_2

#ifdef HOLE_DETECTION
hole_detect_1:
#if 1
	movl	%ebx, %eax
	movl	%ebx, %esi
	movl	%ebx, %ecx
	shll	$1, %esi
	notl	%eax
	shrdl	$1, %edx, %ecx
	orl	$0x92492490, %esi
	orl	$0x49249240, %ecx
	andl	%esi, %eax
	movl	%ebx, %esi
	andl	%ecx, %eax
	shll	$3, %esi
	movl	%ebx, %ecx
	shrdl	$3, %edx, %ecx
	orl	$0x70070070, %esi
	orl	$0x0e00e000, %ecx
	andl	%esi, %eax
	movl	%ebx, %esi
	andl	%ecx, %eax
	shll	$12, %esi
	movl	%ebx, %ecx
	shrdl	$12, %edx, %ecx
	orl	$0x0000fff0, %esi
	orl	$0x00000000, %ecx
	andl	%esi, %eax
	andl	%ecx, %eax
	jnz 	retract_piece
#endif
	movl	%edx, %eax
	movl	%edx, %esi
	movl	%edx, %ecx
	shldl	$1, %ebx, %esi
	notl	%eax
	shrl	$1, %ecx
	orl	$0x24924924, %esi
	orl	$0x92492492, %ecx
	andl	%esi, %eax
	movl	%edx, %esi
	andl	%ecx, %eax
	shldl	$3, %ebx, %esi
	movl	%edx, %ecx
	shrl	$3, %ecx
	orl	$0x00700700, %esi
	orl	$0xe00e00e0, %ecx
	andl	%esi, %eax
	movl	%edx, %esi
	andl	%ecx, %eax
	shldl	$12, %ebx, %esi
	movl	%edx, %ecx
	shrl	$12, %ecx
	orl	$0x00000000, %esi
	orl	$0xfff00000, %ecx
	andl	%esi, %eax
	andl	%ecx, %eax
	jnz 	retract_piece
#endif

find_firstbit:		
	notl	%ebx
	bsf	%ebx, %ecx
	notl	%ebx
pattern_1:	
	# pattern code
	movl	%ebx, %edi
	shrdl	%cl, %edx, %edi
	map_pattern
	movl	$first_piece, %eax
	leal	1(%edi, %ecx,8), %edi

	movl	(%eax),%ecx
	jmpl	*(%ecx,%edi,4)


	.p2align 4,,15
.globl solve_asm_32
	.type	solve_asm_32,@function
solve_asm_32:
	movl	(%ecx),%esi
	pushl	%edi
	movl	%esi,(%eax)

	pushl	%eax
	pushl	%ecx

#ifdef COUNT_PLACED
	incl	placedP-4(,%ebp,4)
	incl	%ebp
#endif
	incl	placed

#ifdef HOLE_DETECTION
hole_detect_2:	
	movl	%edx, %eax
	movl	%edx, %esi
	movl	%edx, %ecx
	shll	$1, %esi
	notl	%eax
	shrl	$1, %ecx
	orl	$0x24924925, %esi
	orl	$0x92492492, %ecx
	andl	%esi, %eax
	movl	%edx, %esi
	andl	%ecx, %eax
	shll	$3, %esi
	movl	%edx, %ecx
	shrl	$3, %ecx
	orl	$0x00700707, %esi
	orl	$0xe00e00e0, %ecx
	andl	%esi, %eax
	movl	%edx, %esi
	andl	%ecx, %eax
	shll	$12, %esi
	movl	%edx, %ecx
	shrl	$12, %ecx
	orl	$0x00000fff, %esi
	orl	$0xfff00000, %ecx
	andl	%esi, %eax
	andl	%ecx, %eax
	jnz 	retract_piece
#endif

find_firstbit_32:	
	notl	%edx
	bsf	%edx, %ecx
	jz      found_solution
	notl	%edx
		
pattern_2:	
	# pattern code
	movl	%edx, %edi
	shrl	%cl, %edi
	map_pattern
	movl	$first_piece, %eax
	leal	8*32+1(%edi, %ecx,8), %edi

	movl	(%eax), %ecx
	jmpl	*(%ecx,%edi,4)

	.p2align 4,,15
.globl next_piece
	.type	next_piece,@function
next_piece:	
	movl	%ecx, %eax

	movl	(%ecx), %ecx
	orl	%ecx, %ecx
	jz	retract_piece

	jmpl	*(%ecx,%edi,4)

found_solution:	
	incl	solutions

.globl retract_piece
	.type	retract_piece,@function
retract_piece:
	popl	%ecx
	popl	%eax
	popl	%edi
	movl	%ecx, (%eax)
#ifdef COUNT_PLACED
	decl	%ebp
#endif
	ret

